function Base.show(io::IO, G::PermGroup)
    print(io, "PermGroup( ")
    join(io, gens(G), ", ")
    return print(io, " )")
end

function Base.show(io::IO, ::MIME"text/plain", G::PermGroup)
    o = isdefined(G, :stabchain) ? " of order $(order(StabilizerChain(G)))" : ""
    ngen = ngens(G)

    println(
        io,
        "Permutation group on ",
        ngen,
        " generator",
        ngen > 1 ? "s" : "",
        o,
        " generated by",
    )
    return Base.print_array(io, gens(G))
end
